com.smartgwt.client.widgets.drawing

## Class DrawOval

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawOval

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawOval
      extends DrawItem

  DrawItem subclass to render oval shapes, including circles.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, configOnly, factoryCreated, factoryProperties, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawOval()`
    `DrawOval(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `Point` | `getCenter()` Get the center of the oval.
    `Point` | `getCenterPoint()` Center point of the oval.
    `int` | `getHeight()` Height in pixels relative to the `local coordinate system`.
    `int` | `getLeft()` Left coordinate in pixels relative to the `local coordinate system`.
    `static DrawOval` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `int` | `getRadiusX()` Returns the horizontal radius of the DrawOval.
    `int` | `getRadiusY()` Returns the vertical radius of the DrawOval.
    `TitleRotationMode` | `getTitleRotationMode()` The mode in which the `titleLabel` (if shown) is rotated with this draw item.
    `int` | `getTop()` Top coordinate in pixels relative to the `local coordinate system`.
    `int` | `getWidth()` Width in pixels relative to the `local coordinate system`.
    `void` | `moveBy(int dX, int dY)` Move the drawOval by the specified delta
    `void` | `moveTo(java.lang.Integer left, java.lang.Integer top)` Move the drawOval to the specified left/top position.
    `void` | `resizeBy(int dX, int dY)` Resize by the specified delta.
    `void` | `resizeTo(java.lang.Integer width, java.lang.Integer height)` Resize to the specified size.
    `void` | `setCenterPoint(Point centerPoint)` Center point of the oval.
    `static void` | `setDefaultProperties(DrawOval drawOvalProperties)` Class level method to set the default properties of this class.
    `void` | `setHeight(int height)` Height in pixels relative to the `local coordinate system`.
    `void` | `setLeft(int left)` Left coordinate in pixels relative to the `local coordinate system`.
    `void` | `setOval(int cx, int cy, int rx, int ry)` Resize and reposition the drawOval by setting its radius, and centerPoint.
    `void` | `setRadii(int rx, int ry)` Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
    `void` | `setRadius(java.lang.Integer radius)` Radius of the oval.
    `void` | `setRect(java.lang.Integer left, java.lang.Integer top, java.lang.Integer width, java.lang.Integer height)` Move and resize the drawOval to match the specified coordinates and size.
    `void` | `setTitleRotationMode(TitleRotationMode titleRotationMode)` The mode in which the `titleLabel` (if shown) is rotated with this draw item.
    `void` | `setTop(int top)` Top coordinate in pixels relative to the `local coordinate system`.
    `void` | `setWidth(int width)` Width in pixels relative to the `local coordinate system`.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, changeAutoChildDefaults, changeAutoChildDefaults, changeAutoChildDefaults, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getBoundingBoxAsDouble, getCanDrag, getCanHover, getCanvasAutoChild, getContextMenu, getCornerResizeKnob, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawItemAutoChild, getDrawPane, getEditProxyConstructor, getEndArrow, getEndKnob, getEventOpaque, getFillColor, getFillGradient, getFillGradientAsString, getFillOpacity, getFormItemAutoChild, getHoverDelay, getHoverHTML, getKeepInParentRect, getKnobs, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnob, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRef, getResizeBoundingBox, getResizeBoundingBoxAsDouble, getResizeKnobPoints, getResizeOutline, getResizeViaLocalTransformOnly, getRotation, getRotationAsDouble, getScale, getShadow, getShowHover, getShowResizeOutline, getShowTitleLabelBackground, getSideResizeKnob, getStartArrow, getStartKnob, getSvgString, getTitle, getTitleLabel, getTitleLabelBackground, getTitleLabelPadding, getTranslate, getXShearFactor, getYShearFactor, hide, hideAllKnobs, hideKnobs, hideKnobs, hover, isInBounds, isPointInPath, rotateBy, rotateTo, scaleBy, scaleTo, setAttribute, setAttribute, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setCanDrag, setCanHover, setCenterPoint, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEditProxyConstructor, setEndArrow, setEventOpaque, setFillColor, setFillGradient, setFillGradient, setFillOpacity, setHoverDelay, setKeepInParentRect, setKeepInParentRect, setKnobs, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setPropertyValue, setProportionalResizeModifiers, setProportionalResizing, setResizeKnobPoints, setResizeViaLocalTransformOnly, setRotation, setRotation, setScale, setShadow, setShapeData, setShowHover, setShowResizeOutline, setShowTitleLabelBackground, setStartArrow, setTitle, setTitleLabelPadding, setTranslate, setXShearFactor, setYShearFactor, show, showAllKnobs, showKnobs, showKnobs, supportsEndArrow, supportsStartArrow`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `applyFactoryProperties, asSGWTComponent, createJsObj, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, getTestInstance, hasAutoAssignedID, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setFactoryCreated, setID, setJavaScriptObject, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawOval

          public DrawOval()

    - #### DrawOval

          public DrawOval(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawOval getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setCenterPoint

          public void setCenterPoint(Point centerPoint)

      Center point of the oval. If unset, derived from left/top/width/height.
      If this method is called after the component has been drawn/initialized: Change the center point for this oval.
      Parameters:
        `centerPoint` - left coordinate (in the global coordinate system). Default value is null

    - #### getCenterPoint

          public Point getCenterPoint()

      Center point of the oval. If unset, derived from left/top/width/height.
      Returns:
        Point

    - #### setHeight

          public void setHeight(int height)

      Height in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the height of the drawOval
      Parameters:
        `height` - new height. Default value is 100

    - #### getHeight

          public int getHeight()

      Height in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setLeft

          public void setLeft(int left)

      Left coordinate in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the left coordinate of the drawOval
      Parameters:
        `left` - new left coordinate. Default value is 0

    - #### getLeft

          public int getLeft()

      Left coordinate in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setRadius

          public void setRadius(java.lang.Integer radius)

      Radius of the oval. Since this is used to initialize the `horizontal` and `vertical` radii, then the oval is a circle.

      If unset, the horizontal and vertical radii are set to half the `width` and `height`.
      If this method is called after the component has been drawn/initialized: Resize the drawOval by setting its radius, and retaining its current center point. Equivalent to `setRadii(radius, radius)`.

      Parameters:
        `radius` - new radius. This will be applied on both axes, meaning calling this method will always result in the DrawOval being a circle.. Default value is null
      See Also:
        `getRadiusX()`, `getRadiusY()`

    - #### setTitleRotationMode

          public void setTitleRotationMode(TitleRotationMode titleRotationMode)
                                    throws java.lang.IllegalStateException

      The mode in which the `titleLabel` (if shown) is rotated with this draw item.

      Note : This is an advanced setting

      Overrides:
        `setTitleRotationMode` in class `DrawItem`
      Parameters:
        `titleRotationMode` - Default value is "withItemAlwaysUp"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the underlying component has been created
      See Also:
        `DrawItem.setTitle(java.lang.String)`

    - #### getTitleRotationMode

          public TitleRotationMode getTitleRotationMode()

      The mode in which the `titleLabel` (if shown) is rotated with this draw item.
      Overrides:
        `getTitleRotationMode` in class `DrawItem`
      Returns:
        TitleRotationMode
      See Also:
        `DrawItem.getTitle()`

    - #### setTop

          public void setTop(int top)

      Top coordinate in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the top coordinate of the drawOval
      Parameters:
        `top` - new top coordinate. Default value is 0

    - #### getTop

          public int getTop()

      Top coordinate in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### setWidth

          public void setWidth(int width)

      Width in pixels relative to the `local coordinate system`.
      If this method is called after the component has been drawn/initialized: Set the width of the drawOval
      Parameters:
        `width` - new width. Default value is 100

    - #### getWidth

          public int getWidth()

      Width in pixels relative to the `local coordinate system`.
      Returns:
        int

    - #### getCenter

          public Point getCenter()

      Get the center of the oval.
      Overrides:
        `getCenter` in class `DrawItem`
      Returns:
        the center point

    - #### getRadiusX

          public int getRadiusX()

      Returns the horizontal radius of the DrawOval.
      Returns:
        the horizontal radius.
      See Also:
        `setRadii(int, int)`

    - #### getRadiusY

          public int getRadiusY()

      Returns the vertical radius of the DrawOval.
      Returns:
        the vertical radius.
      See Also:
        `setRadii(int, int)`

    - #### moveBy

          public void moveBy(int dX,
                             int dY)

      Move the drawOval by the specified delta
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to move horizontally
        `dY` - number of pixels to move vertically

    - #### moveTo

          public void moveTo(java.lang.Integer left,
                             java.lang.Integer top)

      Move the drawOval to the specified left/top position. You may also call `setCenterPoint()` to reposition the oval around a new center position.
      Overrides:
        `moveTo` in class `DrawItem`
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate

    - #### resizeBy

          public void resizeBy(int dX,
                               int dY)

      Resize by the specified delta. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `setRadii()` to change the radius in either direction without modifying the centerpoint.
      Overrides:
        `resizeBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to resize by horizontally
        `dY` - number of pixels to resize by vertically

    - #### resizeTo

          public void resizeTo(java.lang.Integer width,
                               java.lang.Integer height)

      Resize to the specified size. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `setRadii()` to change the radius in either direction without modifying the centerpoint.
      Overrides:
        `resizeTo` in class `DrawItem`
      Parameters:
        `width` - new width
        `height` - new height

    - #### setOval

          public void setOval(int cx,
                              int cy,
                              int rx,
                              int ry)

      Resize and reposition the drawOval by setting its radius, and centerPoint.
      Parameters:
        `cx` - new horizontal center point coordinate
        `cy` - new vertical center point coordinate
        `rx` - new horizontal radius
        `ry` - new vertical radius

    - #### setRadii

          public void setRadii(int rx,
                               int ry)

      Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
      Parameters:
        `rx` - new horizontal radius
        `ry` - new vertical radius
      See Also:
        `getRadiusX()`, `getRadiusY()`

    - #### setRect

          public void setRect(java.lang.Integer left,
                              java.lang.Integer top,
                              java.lang.Integer width,
                              java.lang.Integer height)

      Move and resize the drawOval to match the specified coordinates and size.
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate
        `width` - new width
        `height` - new height

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawOval drawOvalProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `drawOvalProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`